package com.fr.plugin;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;

@Visualization(category = "WPS配置")
public class WPSConfig extends DefaultConfiguration {

    private static volatile WPSConfig config = null;

    public static WPSConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(WPSConfig.class);
        }
        return config;
    }

    @Identifier(value = "appKey", name = "appkey", description = "", status = Status.SHOW)
    private Conf<String> appKey = Holders.simple("313a380c67bb491ca11fb47bffd3ba28");
    @Identifier(value = "appid", name = "Appid", description = "", status = Status.SHOW)
    private Conf<String> appid = Holders.simple("98d8ac1a058c4fb4b32478c0d2319dff");

    @Identifier(value = "appsecret", name = "数据连接名", description = "", status = Status.SHOW)
    private Conf<String> appsecret = Holders.simple("JNSaaSFinAuditGuoJin");
    @Identifier(value = "domainName", name = "文件表名", description = "", status = Status.SHOW)
    private Conf<String> domainName = Holders.simple("PD_File_Catalog");

    @Identifier(value = "frHost", name = "当前fr的地址", description = "", status = Status.HIDE)
    private Conf<String> frHost = Holders.simple("https://zzliap.ngrok2.xiaomiqiu.cn/webroot/decision");

    public  String  getFrHost() {
        return frHost.get();
    }

    public void setFrHost( String frHost) {
        this.frHost .set(frHost);
    }

    public String getAppid() {
        return appid.get();
    }

    public void setAppid(String appid) {
        this.appid.set(appid);
    }

    public String getAppKey() {
        return appKey.get();
    }

    public void setAppKey(String appKey) {
        this.appKey.set(appKey);
    }

    public String getAppsecret() {
        return appsecret.get();
    }

    public void setAppsecret(String appsecret) {
        this.appsecret.set(appsecret);
    }

    public String getDomainName() {
        return domainName.get();
    }

    public void setDomainName(String domainName) {
        this.domainName.set(domainName);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        WPSConfig clone = (WPSConfig) super.clone();
        clone.appKey = (Conf<String>) this.appKey.clone();
        clone.appsecret = (Conf<String>) this.appKey.clone();
        clone.domainName = (Conf<String>) this.appKey.clone();
        clone.appid = (Conf<String>) this.appid.clone();
        clone.frHost = (Conf<String>) this.frHost.clone();
        return clone;
    }
}
