package com.fr.plugin;

import com.fr.decision.fun.HttpHandler;
import com.fr.decision.fun.impl.AbstractHttpHandlerProvider;
import com.fr.plugin.api.*;
import com.fr.plugin.transform.ExecuteFunctionRecord;
import com.fr.plugin.transform.FunctionRecorder;

@FunctionRecorder
/**
 * url处理器需要在这里注册
 */
public class WPSHandlerProvider extends AbstractHttpHandlerProvider {

    public WPSHandlerProvider() {
        WPSConfig.getInstance();
    }

    @Override
    @ExecuteFunctionRecord
    public HttpHandler[] registerHandlers() {
        return new HttpHandler[]{
                new DownloadApi(),
                new FileHistoryApi(),
                new FileInfoApi(),
                new EditorApi(),
                new FileRenameApi(),
                new FileSaveApi(),
                new FileVersionApi(),
                new NotifyApi(),
                new OnlineApi(),
                new UserInfoApi(),
        };
    }

}
