package com.fr.plugin;

import com.fr.decision.fun.impl.AbstractURLAliasProvider;
import com.fr.decision.webservice.url.alias.URLAlias;
import com.fr.decision.webservice.url.alias.URLAliasFactory;

/**
 * 将长连接转换为短连接
 * 参考文档：
 * https://wiki.fanruan.com/display/PD/com.fr.decision.fun.URLAliasProvider
 */
public class WPSURLAliasBridge extends AbstractURLAliasProvider
{

    @Override
    public URLAlias[] registerAlias() {
        //像这样配置之后再访问/api就可以通过http(s)://ip:port/webroot/decision/url/api。 进行访问
        return new URLAlias[]{
                URLAliasFactory.createPluginAlias("/v1/3rd/file/info", "/v1/3rd/file/info", true),
                URLAliasFactory.createPluginAlias("/editorWps", "/editorWps", true),
                URLAliasFactory.createPluginAlias("/v1/3rd/user/info", "/v1/3rd/user/info", true),
                URLAliasFactory.createPluginAlias("/v1/3rd/file/save", "/v1/3rd/file/save", true),
                URLAliasFactory.createPluginAlias("/v1/3rd/file/online", "/v1/3rd/file/online", true),
                URLAliasFactory.createPluginAlias("/v1/3rd/file/version/:version", "/v1/3rd/file/version/:version", true),
                URLAliasFactory.createPluginAlias("/v1/3rd/file/rename", "/v1/3rd/file/rename", true),
                URLAliasFactory.createPluginAlias("/v1/3rd/file/history", "/v1/3rd/file/history", true),
                URLAliasFactory.createPluginAlias("/v1/3rd/onnotify", "/v1/3rd/onnotify", true),
        };
    }
}
