package com.fr.plugin.api;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.general.IOUtils;
import com.fr.plugin.WPSConfig;
import com.fr.plugin.models.GetFileModel;
import com.fr.plugin.utils.DbUtils;
import com.fr.plugin.utils.ErrorUtils;
import com.fr.stable.StringUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.OutputStream;
import java.util.List;
import java.util.Map;


public class DownloadApi extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return null;
    }


    @Override
    public String getPath() {
        return "/v1/3rd/file/info/fileDownload";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest request, HttpServletResponse response) throws Exception {
        String fileId = WebUtils.getHTTPRequestParameter(request, "fileId");
        WPSConfig instance = WPSConfig.getInstance();
        DbUtils db = new DbUtils(instance.getAppsecret());
        List<Map<String, String>> list = db.exQuery("select * from " + instance.getDomainName() + " where File_Id =?", fileId);
        if (list.isEmpty()) {
            WebUtils.printAsJSON(response, ErrorUtils.createError(101,"文件不存在","请联系管理员"));
            return;
        }
        Map<String, String> map = list.get(0);
        String fileUrl = map.get("File_Url");
        String fileName = map.get("File_name");
        if (StringUtils.isEmpty(fileUrl)) {
            WebUtils.printAsJSON(response, ErrorUtils.createError(101,"文件保存路径不存在","请联系管理员"));
            return;
        }
        String filePath = fileUrl + fileName;
        File file = new File(filePath);
        if (!file.exists()) {
            WebUtils.printAsJSON(response, ErrorUtils.createError(101,"文件已经被删除","请联系管理员"));
            return;
        }
        response.addHeader("Content-Disposition", "attachment;filename=" + new String(fileName.getBytes()));
        response.addHeader("Content-Length", "" + file.length());
        OutputStream toClient = new BufferedOutputStream(response.getOutputStream());
        response.setContentType("application/octet-stream");
        IOUtils.copyBinaryTo(new FileInputStream(file),toClient);
    }
}
