package com.fr.plugin.api;

import com.fr.decision.authority.data.User;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.plugin.Signature;
import com.fr.plugin.models.GetUserModel;
import com.fr.plugin.models.UserModel;
import com.fr.plugin.utils.ErrorUtils;
import com.fr.plugin.utils.HttpUtils;
import com.fr.report.core.utils.WebUnit;
import com.fr.stable.StringUtils;
import com.fr.third.jodd.util.StringUtil;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;
import org.json.JSONArray;
import org.json.JSONObject;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;


public class UserInfoApi extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return null;
    }


    @Override
    public String getPath() {
        return "/v1/3rd/user/info";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest request, HttpServletResponse httpServletResponse) throws Exception {
        String token = request.getHeader("x-wps-weboffice-token");
        String wSignature = WebUtils.getHTTPRequestParameter(request, "_w_signature");
        if (!Signature.checkSig(request,wSignature)) {
            WebUtils.printAsJSON(httpServletResponse, ErrorUtils.createError(101,"签名错误","请联系管理员"));
            return;
        }
        if (!HttpUtils.checkToken(token)) {
            WebUtils.printAsJSON(httpServletResponse, ErrorUtils.createError(101, "token过期", "请联系管理员"));
            return;
        }
        ServletInputStream inputStream = request.getInputStream();
        String body = HttpUtils.inputStream2String(inputStream);
        if (StringUtils.isNotBlank(body)) {
            JSONObject jsonObject = new JSONObject(body);
            JSONArray ids = jsonObject.getJSONArray("ids");
            int length = ids.length();
            UserService userService = UserService.getInstance();
            ArrayList<UserModel> userModels = new ArrayList<UserModel>();
            for (int i = 0; i < length; i++) {
                String userName = ids.getString(i);
                if (StringUtils.isNotBlank(userName)) {
                    User user = userService.getUserByUserName(userName);
                    UserModel userModel = new UserModel();
                    userModel.setId(userName);
                    userModel.setName(user.getRealName());
                    userModels.add(userModel);
                }
            }
            GetUserModel getUserModel = new GetUserModel();
            getUserModel.setUsers(userModels);
            WebUtils.printAsString(httpServletResponse, HttpUtils.obj2JsonStr(getUserModel));
            return;
        }else{
            WebUtils.printAsJSON(httpServletResponse, ErrorUtils.createError(101,"请求参数中没有信息","请联系管理员"));
            return;
        }
    }
}
