package com.fr.plugin.models;


import javax.servlet.http.HttpServletRequest;
import java.io.Serializable;

/**
 *  id: "132aa30a87064",	 			//文件id,字符串长度小于32
 *         name: "example.doc",				//文件名(必须带文件后缀)
 *         version: 1,				        //当前版本号，位数小于11
 *         size: 200,				        //文件大小，单位为B(文件真实大小，否则会出现异常)
 *         creator: "id0",			        	//创建者id，字符串长度小于32
 *         create_time: 1136185445.			//创建时间，时间戳，单位为秒
 *         modifier: "id1000",			    	//修改者id，字符串长度小于32
 *         modify_time: 1551409818,			//修改时间，时间戳，单位为秒
 *         download_url: "http://www.xxx.cn/v1/file?fid=f132aa30a87064",  //文档下载地址
 *         preview_pages: 3	//限制预览页数
 */
public class FileModel implements Serializable {
    private String id;
    private String name;
    private int version;
    private long size;
    private String modifier;
    private String modify_time;
    private String download_url;
    private int preview_pages = 0;
    private UserAclModel user_acl;
    private WatermarkModel watermark;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getVersion() {
        return version;
    }

    public void setVersion(int version) {
        this.version = version;
    }

    public long getSize() {
        return size;
    }

    public void setSize(long size) {
        this.size = size;
    }

    public String getModifier() {
        return modifier;
    }

    public void setModifier(String modifier) {
        this.modifier = modifier;
    }

    public String getModify_time() {
        return modify_time;
    }

    public void setModify_time(String modify_time) {
        this.modify_time = modify_time;
    }

    public String getDownload_url() {
        return download_url;
    }

    public void setDownload_url(HttpServletRequest request, String id) {
        StringBuffer requestURL = request.getRequestURL();
        this.download_url = requestURL.append("/fileDownload?fileId=").append(id).toString();
    }

    public int getPreview_pages() {
        return preview_pages;
    }

    public void setPreview_pages(int preview_pages) {
        this.preview_pages = preview_pages;
    }

    public UserAclModel getUser_acl() {
        return user_acl;
    }

    public void setUser_acl(UserAclModel user_acl) {
        this.user_acl = user_acl;
    }

    public WatermarkModel getWatermark() {
        return watermark;
    }

    public void setWatermark(WatermarkModel watermark) {
        this.watermark = watermark;
    }
}
